<?php
namespace Planejamento\Logic\Transportadas;

use Geral\Util\DateUtil;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
/**
 * Created by PhpStorm.
 * User: thaisoliveira
 * Date: 21/11/14
 * Time: 10:06
 */
class DistribuicaoCardapio{
    /**
     * Executa procedure para distribuição de acordo com a configuração do serviço e cardápio.
     */
    public static function executaProcedureCalculaEmbServ($cdfilial,$cdservfili,$dtcardapio,$cdcliente,
                                                          $cddestfili,$substitui_dist_atual,$retorno){
        $procedure = new Procedure('CALCULA_EMB_SERV');
        $procedure->addParam(new Param('P_CDFILIAL', Param::PARAM_INPUT, $cdfilial, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDSERVFILI', Param::PARAM_INPUT, $cdservfili, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTCARDAPIO', Param::PARAM_INPUT, $dtcardapio, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDCLIENTE', Param::PARAM_INPUT, $cdcliente, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_CDDESTFILI', Param::PARAM_INPUT, $cddestfili, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SUBSTITUI_DIST_ATUAL', Param::PARAM_INPUT, $substitui_dist_atual, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_RETORNO',  Param::PARAM_OUTPUT, $retorno, Param::PARAM_TYPE_STR, 20));
        $nova_distribuicao = $procedure->call();
        return $nova_distribuicao;
   }

    /**
     * Executa procedure para distribuição de acordo com a configuração feita para filial.
     * @param $dtcardini
     * @param $dtcardfin
     * @param $nrlistaserv
     * @param $substitui_dist_atual
     */
    public static function executaProcedureCalculaEmbListServ($dtcardini, $dtcardfin, $nrlistaserv, $substitui_dist_atual){
        $procedure = new Procedure('CALCULA_EMB_LIST_SERV');
        $procedure->addParam(new Param('P_DTCARDAPIOINI', Param::PARAM_INPUT, $dtcardini, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_DTCARDAPIOFIN', Param::PARAM_INPUT, $dtcardfin, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_NRLISTA_SERV', Param::PARAM_INPUT, $nrlistaserv, Param::PARAM_TYPE_STR));
        $procedure->addParam(new Param('P_SUBSTITUI_DIST_ATUAL', Param::PARAM_INPUT, $substitui_dist_atual, Param::PARAM_TYPE_STR));
        $procedure->call();

    }

    /**
     * Exexuta pocedure para gerar novo codigo de Embalagem da distribuição.
     */
    public static function executaProcedureNovoCodigoEmbdistcard($contador, $sequencial, $qtde, $nrorg){
        $procedure = new Procedure('NOVO_CODIGO_SC');
        $procedure->addParam(new Param ('P_CONTADOR', Param::PARAM_INPUT, $contador, Param::PARAM_TYPE_STR, 11));
        $procedure->addParam(new Param ('P_SEQUENCIAL',  Param::PARAM_OUTPUT, $sequencial, Param::PARAM_TYPE_STR, 20));
        $procedure->addParam(new Param ('P_QTDE', Param::PARAM_INPUT, $qtde, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param ('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_INT));
        $embdistcard = $procedure->call();
        $nrembdistcard = $embdistcard['P_SEQUENCIAL'];
        return $nrembdistcard;
    }

    /**
     * Executa procedurwe para novo codigo de lista que vai ser o codigo da lista de serviços para distribuição a nível de filial.
     * @param $contador
     * @param $sequencial
     * @param $qtde
     * @param $nrorg
     */
    public static function executaProcedureNovoCodigoNrlista($contador, $sequencial, $qtde, $nrorg){
        $procedure = new Procedure('NOVO_CODIGO');
        $procedure->addParam(new Param ('P_CONTADOR', Param::PARAM_INPUT, $contador, Param::PARAM_TYPE_STR, 5));
        $procedure->addParam(new Param ('P_SEQUENCIAL',  Param::PARAM_OUTPUT, $sequencial, Param::PARAM_TYPE_STR, 10));
        $procedure->addParam(new Param ('P_QTDE', Param::PARAM_INPUT, $qtde, Param::PARAM_TYPE_INT));
        $procedure->addParam(new Param ('P_NRORG', Param::PARAM_INPUT, $nrorg, Param::PARAM_TYPE_INT));
    }

    public static function CalculaQuantidadePrato($qtd_pessoa, $comensais){
        $qtd_pessoa = str_replace(',', '.', $qtd_pessoa);
        $qtd_pessoa = (float)$qtd_pessoa;
        $comensais = (float)$comensais;
        $qtd_prato = $qtd_pessoa*$comensais;
        $qtd_prato = str_replace('.', ',', $qtd_prato);
        return $qtd_prato;
    }

    public static function CalculaQtdPratoPessoa($comensais, $qtprato){
        $qtd_pessoa = ($qtprato/$comensais);
        return $qtd_pessoa;

    }

    public static function CalculaQtdComensais($qtdpessoa, $qtdpratodistrib){
        $qtdpratodistrib = str_replace(',', '.', $qtdpratodistrib);
        $qtdpessoa = str_replace(',', '.', $qtdpessoa);
        $comensais = ($qtdpratodistrib/$qtdpessoa);
        $comensais = floor($comensais);
        $comensais = str_replace('.', ',', $comensais);
        return $comensais;

    }

    public static function CalculaQuantidadeContainers($quantidade_prato, $capacidade){
        $total_inteiro =0;
        if($quantidade_prato){
            if($capacidade){
                $quantidade_prato = str_replace(',', '.', $quantidade_prato);
                $qtd_container = ($quantidade_prato/$capacidade);
                if($qtd_container<1){
                    $total_inteiro = 1;
                }else{
                    $string = explode('.', $qtd_container);
                    //$capacidade = floatval($capacidade);
                    $resto = $string[1];
                    $concat ='0'.'.'.$resto;
                    floatval($concat);
                    if($concat>0){
                       $qtd_container = floor($qtd_container);
                        $qtd_container = $qtd_container +1;
                    }
                    $total_inteiro = $qtd_container;
                    $total_inteiro = round($total_inteiro, 2);
                }

            }else{
                tk_abort(tk_get_message_by_name('msg_pla15400_InformeContainer'));
            }

        }
    return $total_inteiro;
    }

    public static function CalculaRestoPrato($qtd_total, $qtd_distribuida){
        $qtd_total = str_replace('.', ',', $qtd_total);
        $qtd_distribuida = str_replace('.', ',', $qtd_distribuida);
        $resto = ($qtd_total - $qtd_distribuida);
        $resto_prato= str_replace('.', ',', $resto);
        return $resto_prato;
    }

    public static function CalculaRestoComensais($comensais_total, $comensais_distribuicao ){
        $comensais_total = str_replace('.', ',', $comensais_total);
        $comensais_distribuicao = str_replace('.', ',', $comensais_distribuicao);
        $resto = ($comensais_total-$comensais_distribuicao);
        $resto_comensais =  str_replace('.', ',', $resto);
        return $resto_comensais;

    }

    public static function InsereCdlista($nrlista, $cdfilial, $cdservico, $nrorg){
        $cdlista = $cdfilial. "_" .$cdservico;
        \Geral\Repositories\Lista::InsertLista($nrlista, $cdlista);

    }

    public static function retornaMenorData($data1, $data2){
        // se a data1 for menor que a data 2, retorna a data1, senao, retorna a data2
        if (self::getIntervaloEmSegundos($data1, $data2) > 0) {
            return $data1;
        } else {
            return $data2;
        }
    }

    public static function buscaObjsPratos($nrdistcard, $nrseqpratcar, $nrorg, $nrembdistcard){
        $retorno = true;
        /**
         * @var \Planejamento\Entities\Itembdistcard $itens Itembdistcard
         */
        $itens = \Planejamento\Entities\Itembdistcard::buscaEmbalagensDoPrato($nrdistcard, $nrseqpratcar, $nrorg);
        $arrays = count($itens);
        if ($itens) {
            if ($arrays > 1) { // está distribuido em outras embalagens, não é possível alterar o valor do campo qtd/pessoa
                $retorno = false;
            } elseif ($arrays == 1) {
                        $itens = $itens[0];
                        $nremb = $itens->getNrembdistcard();
                        if ($nremb == $nrembdistcard) {
                            $retorno = true;
                        }else{
                            $retorno = false;
                        }
            }

        }
        return $retorno;

    }






}