/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOOPERACROP                                            */
/* Tabela : TIPOOPERACROP                                                     */
/*                                                                            */
/* Criao:                                                                   */
/* 29/05/2007 - Pedro Nerino Viol de Lima                                     */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_TIPOOPERACROP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_TIPOOPERACROP
GO


CREATE TRIGGER DTULTATU_TIPOOPERACROP
ON TIPOOPERACROP
FOR INSERT, UPDATE, DELETE
AS

BEGIN

   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'TIPOOPERACROP', null, 'CDFILIAL=' + CDFILIAL + ';IDENTRSAIDOP=' + IDENTRSAIDOP +
                ';CDTIPOOPER=' + CDTIPOOPER + ';IDTPOPERACROP=' + IDTPOPERACROP + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE TIPOOPERACROP
      SET DTULTATUTPOR = GETDATE()
      FROM INSERTED;
   END;
   
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_TIPOOPERACROP','4.11.136';
GO

